;compile with BGLC /BGL C:\FSDynTutorial\Exported\CityBus.asm
header label word
    dw      0001            ; 00 World set number   
    dd      0004CF5EDH          ; 02 North bound        
    dd      0004CF5D5H          ; 06 South bound        
    dd      00E1B249AH          ; 10 East bound         
    dd      00E1B2498H          ; 14 West bound         
    dw      20 dup(0)                               
    dd      (offset OBJECT_DATA) - (offset header)
    dw      33 dup(0)                               

OBJECT_DATA label word                                  
    db  21              ;;LATBAND_REL                   
    dw  0267Ah          ;;lat min (inclusive) 512M units
    dw  0267Bh          ;;lat max (exclusive)           
    dd  (offset OBJECT_0) - (offset OBJECT_DATA)        
    db  0               ;;EOL                           
OBJECT_0 label    BGLCODE
    db  12                      ; NEAR_FAR_HUGE_OBJECT_HEADER
    dd  0004CF5E1h,00E1B2499h           ; latitude,longitude          
    db  100                     ; image power                 
    dd  (offset OBJECT_0_END) - (offset OBJECT_0)             
OBJECT_0_START label word
    IFIN1       OBJECT_0_FAIL, image_complex, 2, 32767
    ADDOBJ      OBJECT_0_SCALE
    SHADOW_CALL OBJECT_0_SCALE
OBJECT_0_FAIL label    BGLCODE
    BGL_JUMP_32 OBJECT_0_END  
OBJECT_0_SCALE label    BGLCODE
    SCALE_AGL   OBJECT_0_RETURN, 10000, 13, 131072, 0004CF5E1h, 08A44h, 00E1B2499h, 0BC84h, 0, 0
    BGL_CALL        OBJECT_0_BEGIN
OBJECT_0_RETURN label word
    BGL_RETURN
OBJECT_0_BEGIN label word
model_outside    label    BGLCODE
    BGL_CALL model_crash
model_shadow label BGLCODE

LOD_0    label    BGLCODE
    BGL_JUMP_32    LOD_0L

model_inside  label    BGLCODE
    BGL_RETURN
model_crash label BGLCODE
    BGL_CRASH_START   model_crash_end, 23
    BGL_CRASH_OCTTREE  crash_end_1
    dw     CRASH_FLAG_OBJECT            ; crash type
    dw     7            ; nodes used
    real4  -21.584961,0.000000,-4.450196      ; Box x,y,z 
    real4  43.170120,14.390040,14.390040      ; Box w,h,d 
    dw   1,   1,   2,   3,   4,   4,   5,   6    ; base offset into node table, one for each top-level branch
    ; So if you take branch 2 (count from 0), you add 2 to indices you encounter on that branch
    ; Nodes (254=empty 255=full, else an index into branch)
    OCTTREE_NODE   255,   0,   0,   0, 255,   0,   0,   0           ; node   0
    OCTTREE_NODE   255, 254, 255, 254, 255, 254, 255, 254           ; node   1
    OCTTREE_NODE   255, 255, 254, 254, 255, 255, 254, 254           ; node   2
    OCTTREE_NODE   255, 254, 254, 254, 255, 254, 254, 254           ; node   3
    OCTTREE_NODE   255, 254, 255, 254, 255, 254, 255, 254           ; node   4
    OCTTREE_NODE   255, 255, 254, 254, 255, 255, 254, 254           ; node   5
    OCTTREE_NODE   255, 254, 254, 254, 255, 254, 254, 254           ; node   6
crash_end_1 label word
model_crash_end label word
    BGL_RETURN

LOD_0L    label    BGLCODE
    include    C:\FSDynTutorial\Exported\CityBus_0.asm



OBJECT_0_END label word
EOF
